Loading...
Searching...
No Matches
pcl::features::ISMModel Struct Reference

The assignment of this structure is to store the statistical/learned weights and other information of the trained Implicit Shape Model algorithm. More...

`#include <pcl/recognition/implicit_shape_model.h>`

## Public Types

using | Ptr = shared_ptr< ISMModel >
using | ConstPtr = shared_ptr< const ISMModel >

## Public Member Functions

| ISMModel ()
| Simple constructor that initializes the structure.
| ISMModel (ISMModel const &copy)
| Copy constructor for deep copy.
virtual | ~ISMModel ()
| Destructor that frees memory.
bool | saveModelToFile (std::string &file_name)
| This method simply saves the trained model for later usage.
bool | loadModelFromfile (std::string &file_name)
| This method loads the trained model from file.
void | reset ()
| this method resets all variables and frees memory.
ISMModel & | operator= (const ISMModel &other)
| Operator overloading for deep copy.

## Public Attributes

std::vector< std::vector< float > > | statistical_weights_ {}
| Stores statistical weights.
std::vector< float > | learned_weights_ {}
| Stores learned weights.
std::vector< unsigned int > | classes_ {}
| Stores the class label for every direction.
std::vector< float > | sigmas_ {}
| Stores the sigma value for each class.
Eigen::MatrixXf | directions_to_center_
| Stores the directions to objects center for each visual word.
Eigen::MatrixXf | clusters_centers_
| Stores the centers of the clusters that were obtained during the visual words clusterization.
std::vector< std::vector< unsigned int > > | clusters_ {}
| This is an array of clusters.
unsigned int | number_of_classes_ {0}
| Stores the number of classes.
unsigned int | number_of_visual_words_ {0}
| Stores the number of visual words.
unsigned int | number_of_clusters_ {0}
| Stores the number of clusters.
unsigned int | descriptors_dimension_ {0}
| Stores descriptors dimension.

## Detailed Description

The assignment of this structure is to store the statistical/learned weights and other information of the trained Implicit Shape Model algorithm.

Definition at line 155 of file implicit_shape_model.h.

## Member Typedef Documentation

## ConstPtr

using pcl::features::ISMModel::ConstPtr = shared_ptr<const ISMModel>

Definition at line 158 of file implicit_shape_model.h.

## Ptr

using pcl::features::ISMModel::Ptr = shared_ptr<ISMModel>

Definition at line 157 of file implicit_shape_model.h.

## Constructor & Destructor Documentation

## ISMModel() [1/2]

pcl::features::ISMModel::ISMModel | ( |  | ) |

default

Simple constructor that initializes the structure.

## ISMModel() [2/2]

pcl::features::ISMModel::ISMModel | ( | ISMModel const & | copy | ) |

Copy constructor for deep copy.

Definition at line 295 of file implicit_shape_model.hpp.

References classes_, clusters_centers_, descriptors_dimension_, directions_to_center_, learned_weights_, number_of_classes_, number_of_clusters_, number_of_visual_words_, reset(), sigmas_, and statistical_weights_.

## ~ISMModel()

pcl::features::ISMModel::~ISMModel | ( |  | ) |

virtual

Destructor that frees memory.

Definition at line 335 of file implicit_shape_model.hpp.

## Member Function Documentation

## loadModelFromfile()

bool pcl::features::ISMModel::loadModelFromfile | ( | std::string & | file_name | ) |

This method loads the trained model from file.

Parameters

  [in] | file_name | path to file which stores trained model

Definition at line 397 of file implicit_shape_model.hpp.

## operator=()

pcl::features::ISMModel & pcl::features::ISMModel::operator= | ( | const ISMModel & | other | ) |

Operator overloading for deep copy.

Definition at line 485 of file implicit_shape_model.hpp.

References classes_, clusters_centers_, descriptors_dimension_, directions_to_center_, learned_weights_, number_of_classes_, number_of_clusters_, number_of_visual_words_, sigmas_, and statistical_weights_.

## reset()

void pcl::features::ISMModel::reset | ( |  | ) |

this method resets all variables and frees memory.

Definition at line 468 of file implicit_shape_model.hpp.

Referenced by ISMModel().

## saveModelToFile()

bool pcl::features::ISMModel::saveModelToFile | ( | std::string & | file_name | ) |

This method simply saves the trained model for later usage.

Parameters

  [in] | file_name | path to file for saving model

Definition at line 342 of file implicit_shape_model.hpp.

## Member Data Documentation

## classes_

std::vector<unsigned int> pcl::features::ISMModel::classes_ {}

Stores the class label for every direction.

Definition at line 196 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## clusters_

std::vector<std::vector<unsigned int> > pcl::features::ISMModel::clusters_ {}

This is an array of clusters.

Each cluster stores the indices of the visual words that it contains.

Definition at line 208 of file implicit_shape_model.h.

## clusters_centers_

Eigen::MatrixXf pcl::features::ISMModel::clusters_centers_

Stores the centers of the clusters that were obtained during the visual words clusterization.

Definition at line 205 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## descriptors_dimension_

unsigned int pcl::features::ISMModel::descriptors_dimension_ {0}

Stores descriptors dimension.

Definition at line 220 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## directions_to_center_

Eigen::MatrixXf pcl::features::ISMModel::directions_to_center_

Stores the directions to objects center for each visual word.

Definition at line 202 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## learned_weights_

std::vector<float> pcl::features::ISMModel::learned_weights_ {}

Stores learned weights.

Definition at line 193 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## number_of_classes_

unsigned int pcl::features::ISMModel::number_of_classes_ {0}

Stores the number of classes.

Definition at line 211 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## number_of_clusters_

unsigned int pcl::features::ISMModel::number_of_clusters_ {0}

Stores the number of clusters.

Definition at line 217 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## number_of_visual_words_

unsigned int pcl::features::ISMModel::number_of_visual_words_ {0}

Stores the number of visual words.

Definition at line 214 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## sigmas_

std::vector<float> pcl::features::ISMModel::sigmas_ {}

Stores the sigma value for each class.

This values were used to compute the learned weights.

Definition at line 199 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## statistical_weights_

std::vector<std::vector<float> > pcl::features::ISMModel::statistical_weights_ {}

Stores statistical weights.

Definition at line 190 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

The documentation for this struct was generated from the following files:

- pcl/recognition/implicit_shape_model.h
- pcl/recognition/impl/implicit_shape_model.hpp